Index: uspace/lib/posix/source/dlfcn.c
===================================================================
--- uspace/lib/posix/source/dlfcn.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/posix/source/dlfcn.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,68 @@
+/*
+ * Copyright (c) 2017 Vojtech Horky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libposix
+ * @{
+ */
+
+#define LIBPOSIX_INTERNAL
+#define __POSIX_DEF__(x) posix_##x
+
+#include "internal/common.h"
+#include "posix/dlfcn.h"
+
+#include "libc/dlfcn.h"
+
+void *posix_dlopen(const char *filename, int flags)
+{
+	if (flags != 0) {
+		fprintf(stderr, "dlopen() not implemented with non-zero flags (%s:%d), something will NOT work.\n", __FILE__, __LINE__);
+	}
+	
+	return dlopen(filename, 0);
+}
+
+void *posix_dlsym(void *handle, const char *symbol)
+{
+	return dlsym(handle, symbol);
+}
+
+int posix_dlclose(void *handle)
+{
+	not_implemented();
+	return 0;
+}
+
+char *posix_dlerror(void)
+{
+	not_implemented();
+	return (char *)"dlerror()";
+}
+
+/** @}
+ */
Index: uspace/lib/posix/source/internal/common.h
===================================================================
--- uspace/lib/posix/source/internal/common.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/posix/source/internal/common.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,5 +38,5 @@
 #include <stdio.h>
 #include <stdlib.h>
-#include <sys/types.h>
+#include <offset.h>
 #include <vfs/vfs.h>
 
Index: uspace/lib/posix/source/stdio.c
===================================================================
--- uspace/lib/posix/source/stdio.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/posix/source/stdio.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -49,5 +49,4 @@
 #include "libc/stdio.h"
 #include "libc/io/printf_core.h"
-#include "libc/stdbool.h"
 #include "libc/str.h"
 #include "libc/malloc.h"
Index: uspace/lib/posix/source/stdlib.c
===================================================================
--- uspace/lib/posix/source/stdlib.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/posix/source/stdlib.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -47,5 +47,5 @@
 #include "posix/unistd.h"
 
-#include "libc/sort.h"
+#include "libc/qsort.h"
 #include "libc/str.h"
 #include "libc/vfs/vfs.h"
@@ -136,27 +136,4 @@
 
 /**
- * Private helper function that serves as a compare function for qsort().
- *
- * @param elem1 First element to compare.
- * @param elem2 Second element to compare.
- * @param compare Comparison function without userdata parameter.
- * @return Relative ordering of the elements.
- */
-static int sort_compare_wrapper(void *elem1, void *elem2, void *userdata)
-{
-	int (*compare)(const void *, const void *) = userdata;
-	int ret = compare(elem1, elem2);
-	
-	/* Native qsort internals expect this. */
-	if (ret < 0) {
-		return -1;
-	} else if (ret > 0) {
-		return 1;
-	} else {
-		return 0;
-	}
-}
-
-/**
  * Array sorting utilizing the quicksort algorithm.
  *
@@ -169,6 +146,5 @@
     int (*compare)(const void *, const void *))
 {
-	/* Implemented in libc with one extra argument. */
-	qsort(array, count, size, sort_compare_wrapper, compare);
+	qsort(array, count, size, compare);
 }
 
Index: uspace/lib/posix/source/time.c
===================================================================
--- uspace/lib/posix/source/time.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/posix/source/time.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -45,10 +45,9 @@
 #include "posix/assert.h"
 
+#include "libc/fibril_synch.h"
 #include "libc/malloc.h"
 #include "libc/task.h"
 #include "libc/stats.h"
-#include "libc/stdbool.h"
 #include "libc/stddef.h"
-#include "libc/thread.h"
 #include "libc/sys/time.h"
 
@@ -315,8 +314,8 @@
 			// TODO: interruptible sleep
 			if (rqtp->tv_sec != 0) {
-				thread_sleep(rqtp->tv_sec);
+				fibril_sleep(rqtp->tv_sec);
 			}
 			if (rqtp->tv_nsec != 0) {
-				thread_usleep(rqtp->tv_nsec / 1000);
+				fibril_usleep(rqtp->tv_nsec / 1000);
 			}
 			return 0;
Index: uspace/lib/posix/source/unistd.c
===================================================================
--- uspace/lib/posix/source/unistd.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/posix/source/unistd.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -45,4 +45,5 @@
 
 #include "libc/task.h"
+#include "libc/thread.h"
 #include "libc/stats.h"
 #include "libc/malloc.h"
@@ -56,4 +57,19 @@
 char **posix_environ = NULL;
 char *posix_optarg;
+
+/**
+ * Sleep for the specified number of seconds.
+ *
+ * Note that POSIX allows this call to be interrupted and then the return
+ * value represents remaining seconds for the sleep. HelenOS does not offer
+ * such functionality and thus always the whole sleep is taken.
+ *
+ * @param seconds Number of seconds to sleep.
+ * @return Always 0 on HelenOS.
+ */
+unsigned int posix_sleep(unsigned int seconds)
+{
+	return thread_sleep(seconds);
+}
 
 /**
Index: uspace/lib/softrend/filter.h
===================================================================
--- uspace/lib/softrend/filter.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/softrend/filter.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,5 +37,4 @@
 #define SOFTREND_FILTER_H_
 
-#include <stdbool.h>
 #include <io/pixelmap.h>
 
Index: uspace/lib/softrend/rectangle.h
===================================================================
--- uspace/lib/softrend/rectangle.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/softrend/rectangle.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,4 +38,5 @@
 
 #include <stdbool.h>
+#include <types/common.h>
 
 extern bool rectangle_intersect(
Index: uspace/lib/usb/include/usb/usb.h
===================================================================
--- uspace/lib/usb/include/usb/usb.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/usb/include/usb/usb.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -35,7 +35,8 @@
 #define LIBUSB_USB_H_
 
+#include <byteorder.h>
 #include <stdbool.h>
 #include <stdint.h>
-#include <byteorder.h>
+#include <types/common.h>
 
 /** Convert 16bit value from native (host) endianness to USB endianness. */
Index: uspace/lib/usb/src/usb.c
===================================================================
--- uspace/lib/usb/src/usb.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/usb/src/usb.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -74,5 +74,5 @@
 const char *usb_str_transfer_type(usb_transfer_type_t t)
 {
-	if (t >= ARRAY_SIZE(str_transfer_type)) {
+	if ((size_t)t >= ARRAY_SIZE(str_transfer_type)) {
 		return "invalid";
 	}
@@ -87,5 +87,5 @@
 const char *usb_str_transfer_type_short(usb_transfer_type_t t)
 {
-	if (t >= ARRAY_SIZE(str_transfer_type_short)) {
+	if ((size_t)t >= ARRAY_SIZE(str_transfer_type_short)) {
 		return "invl";
 	}
Index: uspace/lib/usbdev/src/devdrv.c
===================================================================
--- uspace/lib/usbdev/src/devdrv.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/usbdev/src/devdrv.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -53,5 +53,5 @@
 
 /** USB device structure. */
-typedef struct usb_device {
+struct usb_device {
 	/** Connection to device on USB bus */
 	usb_dev_session_t *bus_session;
@@ -95,5 +95,5 @@
 	 */
 	void *driver_data;
-} usb_device_t;
+};
 
 /** Count number of pipes the driver expects.
@@ -489,10 +489,8 @@
 	int iface_no = -1;
 
-	async_sess_t *sess = devman_parent_device_connect(
-	    ddf_dev_get_handle(ddf_dev), IPC_FLAG_BLOCKING);
+	async_sess_t *sess = ddf_dev_parent_sess_get(ddf_dev);
 	if (sess == NULL)
 		return ENOMEM;
 	const int ret = usb_device_get_info(sess, &h, &iface_no);
-	async_hangup(sess);
 	if (ret != EOK)
 		return ret;
Index: uspace/lib/usbhost/include/usb/host/ddf_helpers.h
===================================================================
--- uspace/lib/usbhost/include/usb/host/ddf_helpers.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/usbhost/include/usb/host/ddf_helpers.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -88,5 +88,5 @@
 hcd_t *dev_to_hcd(ddf_dev_t *dev);
 
-int hcd_ddf_enable_interrupts(ddf_dev_t *device);
+int hcd_ddf_enable_interrupt(ddf_dev_t *device, int);
 int hcd_ddf_get_registers(ddf_dev_t *device, hw_res_list_parsed_t *hw_res);
 int hcd_ddf_setup_interrupts(ddf_dev_t *device,
Index: uspace/lib/usbhost/include/usb/host/usb_transfer_batch.h
===================================================================
--- uspace/lib/usbhost/include/usb/host/usb_transfer_batch.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/usbhost/include/usb/host/usb_transfer_batch.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -41,5 +41,4 @@
 
 #include <assert.h>
-#include <stdbool.h>
 #include <stddef.h>
 #include <stdint.h>
Index: uspace/lib/usbhost/src/ddf_helpers.c
===================================================================
--- uspace/lib/usbhost/src/ddf_helpers.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/usbhost/src/ddf_helpers.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -47,5 +47,4 @@
 #include <ddf/interrupt.h>
 #include <device/hw_res_parsed.h>
-#include <devman.h>
 #include <errno.h>
 #include <fibril_synch.h>
@@ -607,34 +606,29 @@
 }
 
-//TODO: Move this to generic ddf?
-/** Call the parent driver with a request to enable interrupts
+//TODO: Cache parent session in HCD
+/** Call the parent driver with a request to enable interrupt
  *
  * @param[in] device Device asking for interrupts
+ * @param[in] inum Interrupt number
  * @return Error code.
  */
-int hcd_ddf_enable_interrupts(ddf_dev_t *device)
-{
-	assert(device);
-	async_sess_t *parent_sess =
-	    devman_parent_device_connect(ddf_dev_get_handle(device),
-	    IPC_FLAG_BLOCKING);
-	const bool enabled = hw_res_enable_interrupt(parent_sess);
-	async_hangup(parent_sess);
-
-	return enabled ? EOK : EIO;
-}
-
-//TODO: Move this to generic ddf?
+int hcd_ddf_enable_interrupt(ddf_dev_t *device, int inum)
+{
+	async_sess_t *parent_sess = ddf_dev_parent_sess_get(device);
+	if (parent_sess == NULL)
+		return EIO;
+
+	return hw_res_enable_interrupt(parent_sess, inum);
+}
+
+//TODO: Cache parent session in HCD
 int hcd_ddf_get_registers(ddf_dev_t *device, hw_res_list_parsed_t *hw_res)
 {
-	assert(device);
-	assert(hw_res);
-
-	async_sess_t *parent_sess =
-	    devman_parent_device_connect(ddf_dev_get_handle(device),
-	    IPC_FLAG_BLOCKING);
+	async_sess_t *parent_sess = ddf_dev_parent_sess_get(device);
+	if (parent_sess == NULL)
+		return EIO;
+
 	hw_res_list_parsed_init(hw_res);
 	const int ret = hw_res_get_list_parsed(parent_sess, hw_res, 0);
-	async_hangup(parent_sess);
 	if (ret != EOK)
 		hw_res_list_parsed_clean(hw_res);
@@ -663,5 +657,6 @@
  * @param[in] gen_irq_code IRQ code generator.
  *
- * @return EOK on success or negative error code
+ * @return IRQ capability handle on success.
+ * @return Negative error code.
  */
 int hcd_ddf_setup_interrupts(ddf_dev_t *device,
@@ -687,22 +682,22 @@
 
 	/* Register handler to avoid interrupt lockup */
-	int ret = register_interrupt_handler(device, irq, handler, &irq_code);
+	const int irq_cap = register_interrupt_handler(device, irq, handler,
+	    &irq_code);
 	irq_code_clean(&irq_code);
-	if (ret != EOK) {
+	if (irq_cap < 0) {
 		usb_log_error("Failed to register interrupt handler: %s.\n",
-		    str_error(ret));
-		return ret;
+		    str_error(irq_cap));
+		return irq_cap;
 	}
 
 	/* Enable interrupts */
-	ret = hcd_ddf_enable_interrupts(device);
+	int ret = hcd_ddf_enable_interrupt(device, irq);
 	if (ret != EOK) {
 		usb_log_error("Failed to enable interrupts: %s.\n",
 		    str_error(ret));
-		unregister_interrupt_handler(device, irq);
+		unregister_interrupt_handler(device, irq_cap);
 		return ret;
 	}
-	assert(irq > 0);
-	return irq;
+	return irq_cap;
 }
 
@@ -796,6 +791,8 @@
 	interrupt_handler_t *irq_handler =
 	    driver->irq_handler ? driver->irq_handler : ddf_hcd_gen_irq_handler;
-	const int irq = hcd_ddf_setup_interrupts(device, &hw_res, irq_handler, driver->irq_code_gen);
-	if (!(irq < 0)) {
+	const int irq_cap = hcd_ddf_setup_interrupts(device, &hw_res,
+	    irq_handler, driver->irq_code_gen);
+	bool irqs_enabled = !(irq_cap < 0);
+	if (irqs_enabled) {
 		usb_log_debug("Hw interrupts enabled.\n");
 	}
@@ -812,5 +809,5 @@
 	/* Start hw driver */
 	if (driver->start)
-		ret = driver->start(hcd, !(irq < 0));
+		ret = driver->start(hcd, irqs_enabled);
 	if (ret != EOK) {
 		usb_log_error("Failed to start HCD: %s.\n", str_error(ret));
@@ -819,5 +816,5 @@
 
 	/* Need working irq replacement to setup root hub */
-	if ((irq < 0) && hcd->ops.status_hook) {
+	if (!irqs_enabled && hcd->ops.status_hook) {
 		hcd->polling_fibril = fibril_create(interrupt_polling, hcd);
 		if (hcd->polling_fibril == 0) {
@@ -828,5 +825,5 @@
 		fibril_add_ready(hcd->polling_fibril);
 		usb_log_warning("Failed to enable interrupts: %s."
-		    " Falling back to polling.\n", str_error(irq));
+		    " Falling back to polling.\n", str_error(irq_cap));
 	}
 
@@ -854,5 +851,5 @@
 		driver->stop(hcd);
 err_irq:
-	unregister_interrupt_handler(device, irq);
+	unregister_interrupt_handler(device, irq_cap);
 	if (driver->fini)
 		driver->fini(hcd);
Index: uspace/srv/bd/file_bd/file_bd.c
===================================================================
--- uspace/srv/bd/file_bd/file_bd.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/bd/file_bd/file_bd.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -47,5 +47,4 @@
 #include <stddef.h>
 #include <stdint.h>
-#include <sys/typefmt.h>
 #include <errno.h>
 #include <stdbool.h>
Index: uspace/srv/bd/vbd/disk.c
===================================================================
--- uspace/srv/bd/vbd/disk.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/bd/vbd/disk.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,4 +39,6 @@
 #include <errno.h>
 #include <io/log.h>
+#include <label/empty.h>
+#include <label/label.h>
 #include <loc.h>
 #include <stdio.h>
@@ -75,4 +77,10 @@
 static vbd_part_id_t vbds_part_id = 1;
 
+static int vbds_label_get_bsize(void *, size_t *);
+static int vbds_label_get_nblocks(void *, aoff64_t *);
+static int vbds_label_read(void *, aoff64_t, size_t, void *);
+static int vbds_label_write(void *, aoff64_t, size_t, const void *);
+
+/** Block device operations provided by VBD */
 static bd_ops_t vbds_bd_ops = {
 	.open = vbds_bd_open,
@@ -83,4 +91,12 @@
 	.get_block_size = vbds_bd_get_block_size,
 	.get_num_blocks = vbds_bd_get_num_blocks
+};
+
+/** Provide disk access to liblabel */
+static label_bd_ops_t vbds_label_bd_ops = {
+	.get_bsize = vbds_label_get_bsize,
+	.get_nblocks = vbds_label_get_nblocks,
+	.read = vbds_label_read,
+	.write = vbds_label_write
 };
 
@@ -450,4 +466,5 @@
 {
 	label_t *label = NULL;
+	label_bd_t lbd;
 	vbds_disk_t *disk = NULL;
 	bool block_inited = false;
@@ -467,4 +484,7 @@
 		return ENOMEM;
 
+	/* Must be set before calling label_open */
+	disk->svc_id = sid;
+
 	rc = loc_service_get_name(sid, &disk->svc_name);
 	if (rc != EOK) {
@@ -501,5 +521,8 @@
 	block_inited = true;
 
-	rc = label_open(sid, &label);
+	lbd.ops = &vbds_label_bd_ops;
+	lbd.arg = (void *) disk;
+
+	rc = label_open(&lbd, &label);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed to open label in disk %s.",
@@ -509,5 +532,4 @@
 	}
 
-	disk->svc_id = sid;
 	disk->label = label;
 	disk->block_size = block_size;
@@ -648,4 +670,5 @@
 {
 	label_t *label;
+	label_bd_t lbd;
 	label_info_t linfo;
 	vbds_disk_t *disk;
@@ -683,5 +706,8 @@
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_label_create(%zu) - label_create", sid);
 
-	rc = label_create(sid, ltype, &label);
+	lbd.ops = &vbds_label_bd_ops;
+	lbd.arg = (void *) disk;
+
+	rc = label_create(&lbd, ltype, &label);
 	if (rc != EOK)
 		goto error;
@@ -695,5 +721,8 @@
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "vbds_label_create(%zu) - failure", sid);
 	if (disk->label == NULL) {
-		rc2 = label_open(sid, &label);
+		lbd.ops = &vbds_label_bd_ops;
+		lbd.arg = (void *) disk;
+
+		rc2 = label_open(&lbd, &label);
 		if (rc2 != EOK) {
 			log_msg(LOG_DEFAULT, LVL_ERROR, "Failed to open label in disk %s.",
@@ -713,4 +742,5 @@
 	vbds_disk_t *disk;
 	label_t *label;
+	label_bd_t lbd;
 	int rc;
 
@@ -735,5 +765,8 @@
 	disk->label = NULL;
 
-	rc = label_open(disk->svc_id, &label);
+	lbd.ops = &vbds_label_bd_ops;
+	lbd.arg = (void *) disk;
+
+	rc = label_open(&lbd, &label);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed to open label in disk %s.",
@@ -811,4 +844,10 @@
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Error creating partition.");
+		goto error;
+	}
+
+	rc = label_part_empty(lpart);
+	if (rc != EOK) {
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Error emptying partition.");
 		goto error;
 	}
@@ -1179,4 +1218,32 @@
 }
 
+/** Get block size wrapper for liblabel */
+static int vbds_label_get_bsize(void *arg, size_t *bsize)
+{
+	vbds_disk_t *disk = (vbds_disk_t *)arg;
+	return block_get_bsize(disk->svc_id, bsize);
+}
+
+/** Get number of blocks wrapper for liblabel */
+static int vbds_label_get_nblocks(void *arg, aoff64_t *nblocks)
+{
+	vbds_disk_t *disk = (vbds_disk_t *)arg;
+	return block_get_nblocks(disk->svc_id, nblocks);
+}
+
+/** Read blocks wrapper for liblabel */
+static int vbds_label_read(void *arg, aoff64_t ba, size_t cnt, void *buf)
+{
+	vbds_disk_t *disk = (vbds_disk_t *)arg;
+	return block_read_direct(disk->svc_id, ba, cnt, buf);
+}
+
+/** Write blocks wrapper for liblabel */
+static int vbds_label_write(void *arg, aoff64_t ba, size_t cnt, const void *data)
+{
+	vbds_disk_t *disk = (vbds_disk_t *)arg;
+	return block_write_direct(disk->svc_id, ba, cnt, data);
+}
+
 /** @}
  */
Index: uspace/srv/bd/vbd/types/vbd.h
===================================================================
--- uspace/srv/bd/vbd/types/vbd.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/bd/vbd/types/vbd.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -41,5 +41,5 @@
 #include <atomic.h>
 #include <bd_srv.h>
-#include <label.h>
+#include <label/label.h>
 #include <loc.h>
 #include <stdbool.h>
Index: uspace/srv/bd/vbd/vbd.c
===================================================================
--- uspace/srv/bd/vbd/vbd.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/bd/vbd/vbd.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,4 +39,5 @@
 #include <ipc/services.h>
 #include <ipc/vbd.h>
+#include <label/label.h>
 #include <loc.h>
 #include <macros.h>
Index: uspace/srv/clipboard/clipboard.c
===================================================================
--- uspace/srv/clipboard/clipboard.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/clipboard/clipboard.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -27,13 +27,14 @@
  */
 
+#include <async.h>
+#include <errno.h>
+#include <fibril_synch.h>
+#include <ipc/services.h>
+#include <ipc/clipboard.h>
+#include <loc.h>
+#include <malloc.h>
 #include <stdio.h>
 #include <stdbool.h>
-#include <async.h>
-#include <ns.h>
-#include <ipc/services.h>
-#include <ipc/clipboard.h>
-#include <malloc.h>
-#include <fibril_synch.h>
-#include <errno.h>
+#include <task.h>
 
 #define NAME  "clipboard"
@@ -43,4 +44,5 @@
 static clipboard_tag_t clip_tag = CLIPBOARD_TAG_NONE;
 static FIBRIL_MUTEX_INITIALIZE(clip_mtx);
+static service_id_t svc_id;
 
 static void clip_put_data(ipc_callid_t rid, ipc_call_t *request)
@@ -179,10 +181,20 @@
 int main(int argc, char *argv[])
 {
+	int rc;
+	
 	printf("%s: HelenOS clipboard service\n", NAME);
-	
 	async_set_fallback_port_handler(clip_connection, NULL);
-	int rc = service_register(SERVICE_CLIPBOARD);
-	if (rc != EOK)
+	
+	rc = loc_server_register(NAME);
+	if (rc != EOK) {
+		printf("%s: Failed registering server. (%d)\n", NAME, rc);
 		return rc;
+	}
+	
+	rc = loc_service_register(SERVICE_NAME_CLIPBOARD, &svc_id);
+	if (rc != EOK) {
+		printf("%s: Failed registering service. (%d)\n", NAME, rc);
+		return rc;
+	}
 	
 	printf("%s: Accepting connections\n", NAME);
Index: uspace/srv/fs/cdfs/cdfs_ops.c
===================================================================
--- uspace/srv/fs/cdfs/cdfs_ops.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/fs/cdfs/cdfs_ops.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -52,4 +52,6 @@
 #include <byteorder.h>
 #include <macros.h>
+#include <unaligned.h>
+
 #include "cdfs.h"
 #include "cdfs_endian.h"
@@ -115,4 +117,5 @@
 } cdfs_dir_flag_t;
 
+/** Directory record */
 typedef struct {
 	uint8_t length;
@@ -132,4 +135,22 @@
 } __attribute__((packed)) cdfs_dir_t;
 
+/** Directory record for the root directory */
+typedef struct {
+	uint8_t length;
+	uint8_t ea_length;
+	
+	uint32_t_lb lba;
+	uint32_t_lb size;
+	
+	cdfs_timestamp_t timestamp;
+	uint8_t flags;
+	uint8_t unit_size;
+	uint8_t gap_size;
+	uint16_t_lb sequence_nr;
+	
+	uint8_t name_length;
+	uint8_t name[1];
+} __attribute__((packed)) cdfs_root_dir_t;
+
 typedef struct {
 	uint8_t flags; /* reserved in primary */
@@ -153,5 +174,5 @@
 	uint32_t opt_path_table_msb;
 	
-	cdfs_dir_t root_dir;
+	cdfs_root_dir_t root_dir;
 	uint8_t pad0;
 	
@@ -458,5 +479,6 @@
 		size_t i;
 		for (i = 0; i < dsize / sizeof(uint16_t); i++) {
-			buf[i] = uint16_t_be2host(((uint16_t *)data)[i]);
+			buf[i] = uint16_t_be2host(
+			    ((unaligned_uint16_t *)data)[i]);
 		}
 		
Index: uspace/srv/fs/exfat/exfat_dentry.c
===================================================================
--- uspace/srv/fs/exfat/exfat_dentry.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/fs/exfat/exfat_dentry.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -90,5 +90,5 @@
 void exfat_dentry_get_name(const exfat_name_dentry_t *name, size_t size, uint16_t *dst, size_t *offset)
 {
-	size_t i = 0; 
+	size_t i = 0;
 	while (i < EXFAT_NAME_PART_LEN && *offset < size) {
 		dst[*offset] = uint16_t_le2host(name->name[i]);
@@ -97,4 +97,15 @@
 	}
 	dst[*offset] = '\0';
+}
+
+void exfat_dentry_get_vollabel(const exfat_vollabel_dentry_t *vollabel,
+    size_t size, uint16_t *dst)
+{
+	size_t i = 0;
+	while (i < EXFAT_VOLLABEL_LEN && i < vollabel->size && i < size) {
+		dst[i] = uint16_t_le2host(vollabel->label[i]);
+		i++;
+	}
+	dst[i] = '\0';
 }
 
@@ -130,14 +141,4 @@
 }
 
-size_t exfat_utf16_length(const uint16_t *wstr)
-{
-	size_t len = 0;
-	
-	while (*wstr++ != 0)
-		len++;
-	
-	return len;
-}
-
 /**
  * @}
Index: uspace/srv/fs/exfat/exfat_dentry.h
===================================================================
--- uspace/srv/fs/exfat/exfat_dentry.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/fs/exfat/exfat_dentry.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,4 +34,5 @@
 #define EXFAT_EXFAT_DENTRY_H_
 
+#include <stddef.h>
 #include <stdint.h>
 #include <stdbool.h>
@@ -39,4 +40,5 @@
 #define EXFAT_FILENAME_LEN	255
 #define EXFAT_NAME_PART_LEN	15
+#define EXFAT_VOLLABEL_LEN	11
 
 #define EXFAT_TYPE_UNUSED	0x00
@@ -155,5 +157,6 @@
 extern void exfat_dentry_get_name(const exfat_name_dentry_t *, size_t,
     uint16_t *, size_t *);
-
+extern void exfat_dentry_get_vollabel(const exfat_vollabel_dentry_t *, size_t,
+    uint16_t *);
 
 extern bool exfat_valid_char(wchar_t);
Index: uspace/srv/fs/exfat/exfat_directory.c
===================================================================
--- uspace/srv/fs/exfat/exfat_directory.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/fs/exfat/exfat_directory.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -260,4 +260,32 @@
 }
 
+int exfat_directory_read_vollabel(exfat_directory_t *di, char *label,
+    size_t size)
+{
+	uint16_t wlabel[EXFAT_VOLLABEL_LEN + 1];
+	exfat_dentry_t *d = NULL;
+	int rc;
+	aoff64_t start_pos = 0;
+
+	start_pos = di->pos;
+
+	rc = exfat_directory_seek(di, 0);
+	if (rc != EOK)
+		return rc;
+
+	rc = exfat_directory_find(di, EXFAT_DENTRY_VOLLABEL, &d);
+	if (rc != EOK)
+		return rc;
+
+	exfat_dentry_get_vollabel(&d->vollabel, EXFAT_VOLLABEL_LEN, wlabel);
+
+	rc = utf16_to_str(label, size, wlabel);
+	if (rc != EOK)
+		return rc;
+
+	exfat_directory_seek(di, start_pos);
+	return EOK;
+}
+
 static uint16_t exfat_directory_set_checksum(const uint8_t *bytes, size_t count)
 {
@@ -371,5 +399,5 @@
 	ds.stream.valid_data_size = 0;
 	ds.stream.data_size = 0;
-	ds.stream.name_size = exfat_utf16_length(wname);
+	ds.stream.name_size = utf16_wsize(wname);
 	ds.stream.hash = host2uint16_t_le(exfat_name_hash(wname, uctable, 
 	    uctable_chars));
Index: uspace/srv/fs/exfat/exfat_directory.h
===================================================================
--- uspace/srv/fs/exfat/exfat_directory.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/srv/fs/exfat/exfat_directory.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -71,8 +71,10 @@
 extern int exfat_directory_read_file(exfat_directory_t *, char *, size_t,
     exfat_file_dentry_t *, exfat_stream_dentry_t *);
+extern int exfat_directory_read_vollabel(exfat_directory_t *, char *, size_t);
 extern int exfat_directory_sync_file(exfat_directory_t *, exfat_file_dentry_t *,
     exfat_stream_dentry_t *);
 extern int exfat_directory_write_file(exfat_directory_t *, const char *);
 extern int exfat_directory_erase_file(exfat_directory_t *, aoff64_t);
+
 
 extern int exfat_directory_expand(exfat_directory_t *);
